#ifndef CALCUL_DE_TRIANGLES_H
#define CALCUL_DE_TRIANGLES_H
#include <stdbool.h>

typedef unsigned int sommet;
typedef unsigned int uint;

typedef struct triangle {
    sommet s0;
    sommet s1;
    sommet s2;
} triangle;

typedef struct ml_sommets {
    struct ml_sommets* suivant;
    sommet sommet;
} ml_sommets;
typedef ml_sommets* liste_sommets;

typedef struct ml_triangles {
    struct ml_triangles* suivant;
    triangle* triangle;
} ml_triangles;
typedef ml_triangles* liste_triangles;

typedef struct liste_adjacence {
    liste_sommets* voisins;
    uint nb_sommets;
} liste_adjacence;

typedef struct matrice_adjacence {
    bool** matrice;
    uint nb_sommets;
} matrice_adjacence;

triangle* creer_triangle(sommet s1, sommet s2, sommet s3);
 void detruire_triangle(triangle* t);
 liste_sommets creer_liste_sommets();
 void detruire_liste_sommets(liste_sommets l);
 void ajouter_sommet(liste_sommets* l, sommet s);
 liste_triangles creer_liste_triangles();
 void detruire_liste_triangles(liste_triangles l);
 void ajouter_triangle(liste_triangles* l, triangle* t);
 liste_adjacence* creer_liste_adjacence(uint nb_sommets);
 void detruire_liste_adjacence(liste_adjacence* l);
 void ajouter_voisins_liste(liste_adjacence* l, sommet s0, sommet s1);
 matrice_adjacence* creer_matrice_adjacence(uint nb_sommets);
 void detruire_matrice_adjacence(matrice_adjacence* m);
 void ajouter_voisins_matrice(matrice_adjacence* m, sommet s0, sommet s1);
 liste_triangles calcul_triangle_1(matrice_adjacence* m);
liste_triangles calcul_triangle_2(liste_adjacence* la);
 liste_triangles calcul_triangle_3(liste_adjacence* la);
 void print_triangle(triangle* t);
 void print_liste_triangles(liste_triangles lt);

#endif
